
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Request_documentsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const request_documents = await db.request_documents.create(
            {
                id: data.id || undefined,
        
        document_type: data.document_type
        ||
        null
            ,
            
        title: data.title
        ||
        null
            ,
            
        is_sensitive: data.is_sensitive
        ||
        false
        
            ,
            
        uploaded_at: data.uploaded_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await request_documents.setService_request( data.service_request || null, {
            transaction,
        });
        
        await request_documents.setUploaded_by_user( data.uploaded_by_user || null, {
            transaction,
        });
        
        await request_documents.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.request_documents.getTableName(),
                belongsToColumn: 'files',
                belongsToId: request_documents.id,
            },
            data.files,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.request_documents.getTableName(),
                belongsToColumn: 'images',
                belongsToId: request_documents.id,
            },
            data.images,
            options,
        );
        

        return request_documents;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const request_documentsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                document_type: item.document_type
            ||
            null
            ,
            
                title: item.title
            ||
            null
            ,
            
                is_sensitive: item.is_sensitive
            ||
            false
        
            ,
            
                uploaded_at: item.uploaded_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const request_documents = await db.request_documents.bulkCreate(request_documentsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < request_documents.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.request_documents.getTableName(),
                    belongsToColumn: 'files',
                    belongsToId: request_documents[i].id,
                },
                data[i].files,
                options,
            );
        }
        
        for (let i = 0; i < request_documents.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.request_documents.getTableName(),
                    belongsToColumn: 'images',
                    belongsToId: request_documents[i].id,
                },
                data[i].images,
                options,
            );
        }
        

        return request_documents;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const request_documents = await db.request_documents.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.document_type !== undefined) updatePayload.document_type = data.document_type;
        
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.is_sensitive !== undefined) updatePayload.is_sensitive = data.is_sensitive;
        
        
        if (data.uploaded_at !== undefined) updatePayload.uploaded_at = data.uploaded_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await request_documents.update(updatePayload, {transaction});

        
        
        if (data.service_request !== undefined) {
            await request_documents.setService_request(
              
              data.service_request,
              
              { transaction }
            );
        }
        
        if (data.uploaded_by_user !== undefined) {
            await request_documents.setUploaded_by_user(
              
              data.uploaded_by_user,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await request_documents.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.request_documents.getTableName(),
                belongsToColumn: 'files',
                belongsToId: request_documents.id,
            },
            data.files,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.request_documents.getTableName(),
                belongsToColumn: 'images',
                belongsToId: request_documents.id,
            },
            data.images,
            options,
        );
        

        return request_documents;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const request_documents = await db.request_documents.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of request_documents) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of request_documents) {
                await record.destroy({transaction});
            }
        });


        return request_documents;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const request_documents = await db.request_documents.findByPk(id, options);

        await request_documents.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await request_documents.destroy({
            transaction
        });

        return request_documents;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const request_documents = await db.request_documents.findOne(
            { where },
            { transaction },
        );

        if (!request_documents) {
            return request_documents;
        }

        const output = request_documents.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.service_request = await request_documents.getService_request({
            transaction
        });
        
        
        output.uploaded_by_user = await request_documents.getUploaded_by_user({
            transaction
        });
        
        
        output.files = await request_documents.getFiles({
            transaction
        });
        
        
        output.images = await request_documents.getImages({
            transaction
        });
        
        
        output.organizations = await request_documents.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.service_requests,
        as: 'service_request',
        
        where: filter.service_request ? {
          [Op.or]: [
            { id: { [Op.in]: filter.service_request.split('|').map(term => Utils.uuid(term)) } },
            {
              summary: {
                [Op.or]: filter.service_request.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'uploaded_by_user',
        
        where: filter.uploaded_by_user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.uploaded_by_user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.uploaded_by_user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'files',
      },

      {
        model: db.file,
        as: 'images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'request_documents',
                        'title',
                        filter.title,
                    ),
                };
            }
            

            
            

            
            if (filter.uploaded_atRange) {
                const [start, end] = filter.uploaded_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    uploaded_at: {
                    ...where.uploaded_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    uploaded_at: {
                    ...where.uploaded_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.document_type) {
                where = {
                    ...where,
                document_type: filter.document_type,
            };
            }
            
            if (filter.is_sensitive) {
                where = {
                    ...where,
                is_sensitive: filter.is_sensitive,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.request_documents.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'request_documents',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.request_documents.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

